using System;
using System.IO;
using System.Text;
using System.Xml;

namespace CRPluginWorker
{
   class ServerLocal : ServerBase
   {
      public ServerLocal()
      {
         m_st = ServerType.stLocal;
      }

      public override bool isValid() { return (m_st == ServerType.stLocal && getId().Length > 0 && getAddress().Length > 0); }

      public override bool populate(XmlNode p_n)
      {
         if (p_n == null) { return (false); }
         try
         {
            for(int i = 0; i < p_n.ChildNodes.Count; ++i)
            {
               XmlNode n = p_n.ChildNodes[i];
               if (n  == null) { continue; }

               if (n.Name == "path")
                  setAddress(n.InnerText);
               else if (n.Name == "name")
                  setId(n.InnerText);
            }
         }
         catch (Exception) {}
         return (isValid());
      }

      public override string fetchReportList(out string p_strError)
      {
         string strResult = "";
         p_strError = "";
         try
         {
            string[] astr = Directory.GetFiles(getAddress(), "*.rpt");
            for (int i = 0; astr != null && i < astr.Length; ++i)
               strResult += buildReportInfoObject( buildReportId(astr[i]), Path.GetFileName(astr[i]), Path.GetFileNameWithoutExtension(astr[i]), "");
         }
         catch (Exception p_exception) { p_strError = "Report list fetch failed for server " + getId() + ": " + p_exception.Message; }
         return (strResult);
      }

      public override string fetchReport(string p_strReportId, out string p_strError)
      {
         string strResult = "";
         p_strError = "";
         try
         {
            string strServer = "";
            string strReport = decompileReportId(p_strReportId, out strServer);

            if (File.Exists(Path.Combine(getAddress(), strReport)))
               strResult = Path.Combine(getAddress(), strReport);
         }
         catch (Exception p_exception) { p_strError = "Report fetch failed for server " + getId() + ": " + p_exception.Message; }
         return (strResult);
      }

      public override bool isValidReport(string p_strReportId)
      {
         string str = "";
         try
         {
            string strReport = decompileReportId(p_strReportId, out str);
         }
         catch (Exception) {}
         return (str == getId());
      }
   }
}
